cryptol-2.2.6: Cryptol: The Language of Cryptography

Copyright | (c) 2013-2015 Galois, Inc.
License | BSD3
Maintainer | cryptol@galois.com
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Cryptol.TypeCheck.PP

Description

Synopsis

- type NameMap = IntMap String
- data WithNames a = WithNames a NameMap
- emptyNameMap :: NameMap
- ppWithNamesPrec :: PP (WithNames a) => NameMap -> Int -> a -> Doc
- ppWithNames :: PP (WithNames a) => NameMap -> a -> Doc
- intToName :: Int -> String
- nameList :: [String] -> [String]
- dump :: PP (WithNames a) => a -> String
- module Cryptol.Utils.PP

# Documentation

type NameMap = IntMap String Source

data WithNames a Source

This packages together a type with some names to be used to display the variables. It is used for pretty printing types.

Constructors

WithNames a NameMap |

Instances

PP (WithNames Decl) Source |
PP (WithNames DeclGroup) Source |
PP (WithNames Match) Source |
PP (WithNames Expr) Source |
PP (WithNames TVar) Source |
PP (WithNames Type) Source |
PP (WithNames TParam) Source |
PP (WithNames TySyn) Source |
PP (WithNames Schema) Source |
PP (WithNames Module) Source |
PP (WithNames Subst) Source |
PP (WithNames Error) Source |
PP (WithNames Warning) Source |
PP (WithNames DelayedCt) Source |
PP (WithNames Goal) Source |

emptyNameMap :: NameMap Source

ppWithNamesPrec :: PP (WithNames a) => NameMap -> Int -> a -> Doc Source

ppWithNames :: PP (WithNames a) => NameMap -> a -> Doc Source

intToName :: Int -> String Source

nameList :: [String] -> [String] Source

Expand a list of base names into an infinite list of variations.

dump :: PP (WithNames a) => a -> String Source

module Cryptol.Utils.PP